unit uClipboardFilePaste;

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, Forms, SysUtils, ShlObj, Graphics, ExtCtrls, ClipBrd;

procedure CopyFilesToClipboardF(Sender: TObject; aFileList: string);
procedure CopyFilesToClipboardP(aFile: string);

implementation

//                            F like File
procedure CopyFilesToClipboardF(Sender: TObject; aFileList: string);
var
  DropFiles: PDropFiles;
  hGlobal: THandle;
  iLen: integer;
begin
  iLen := Length(aFileList) + 2;
  aFileList := aFileList + #0#0;
  hGlobal := GlobalAlloc(GMEM_SHARE or GMEM_MOVEABLE or GMEM_ZEROINIT,
    SizeOf(TDropFiles) + iLen);
  if (hGlobal = 0) then
    raise Exception.Create('Could not allocate memory.');
  begin
    DropFiles := GlobalLock(hGlobal);
    DropFiles^.pFiles := SizeOf(TDropFiles);
    Move(aFileList[1], (PChar(DropFiles) + SizeOf(TDropFiles))^, iLen);
    GlobalUnlock(hGlobal);
    OpenClipboard(TForm(Sender).Handle);
    EmptyClipboard;
    SetClipboardData(CF_HDROP,hGlobal);
    CloseClipboard;
   end;
end;

//                            P like Picture
procedure CopyFilesToClipboardP(aFile: string);
var
  vBMP: TImage;
begin
  vBMP:=TImage.Create(nil);
  try
    vBMP.Picture.LoadFromFile(aFile);
    Clipboard.Assign(vBMP.Picture.Bitmap);
  finally
    vBMP.Free;
  end;

end;

end.

